/* 
 * Copyright 2024 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Peripherals v14.0
processor: MCXC242
package_id: MCXC242VLH
mcu_data: ksdk2_0
processor_version: 0.16.2
board: FRDM-MCXC242
functionalGroups:
- name: BOARD_InitPeripherals
  UUID: dd007dd6-0d69-4690-ba85-bb55a62de66c
  id_prefix: DEMO_
  selectedCore: core0
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'system'
- type_id: 'system_54b53072540eeeb8f8e9343e71f28176'
- global_system_definitions:
  - user_definitions: ''
  - user_includes: ''
  - global_init: ''
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'gpio_adapter_common'
- type_id: 'gpio_adapter_common'
- global_gpio_adapter_common:
  - quick_selection: 'default'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'uart_cmsis_common'
- type_id: 'uart_cmsis_common'
- global_USART_CMSIS_common:
  - quick_selection: 'default'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "peripherals.h"

/***********************************************************************************************************************
 * BOARD_InitPeripherals functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * DMA initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'DMA'
- type: 'dma'
- mode: 'basic'
- custom_name_enabled: 'true'
- type_id: 'dma_2.1.0'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'DMA'
- config_sets:
  - fsl_dma:
    - dma_table:
      - 0: []
    - dma_channels:
      - 0:
        - apiMode: 'trans'
        - dma_channel:
          - channel_prefix_id: 'ADC0'
          - DMAn: '0'
          - DMA_source: 'kDmaRequestMux0ADC0'
          - enableTriggerPIT: 'false'
          - enable_custom_name: 'false'
        - init_callback: 'false'
        - callback_function: ''
        - callback_user_data: ''
        - enableChannelRequest: 'false'
        - async_req: 'true'
        - transferRequestMode: 'cycle_steal'
        - init_channel_link: 'false'
        - channel_link:
          - linkType: 'kDMA_ChannelLinkDisable'
          - channel1: '0'
          - channel2: '0'
        - auto_align_mode: 'false'
        - enableAutoStop: 'false'
        - enable_interrupt_req: 'true'
        - init_transfer: 'false'
        - transfer_config:
          - dma_transfer_config_t: []
          - srcAddr:
            - width: 'kDMA_Transfersize8bits'
            - enableIncrement: 'false'
            - addr_expr: ''
            - addr_def: ''
            - modulo: 'kDMA_ModuloDisable'
          - dstAddr:
            - width: 'kDMA_Transfersize8bits'
            - enableIncrement: 'false'
            - addr_expr: ''
            - addr_def: ''
            - modulo: 'kDMA_ModuloDisable'
          - transBytes: '1'
        - interrupt_channel:
          - IRQn: 'DMA0_IRQn'
          - enable_priority: 'false'
          - priority: '0'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

  /* Channel ADC0 global variables */
dma_handle_t DEMO_DMA_ADC0_Handle;

static void DEMO_DMA_init(void) {

  /* Channel ADC0 initialization */
  /* Set the source kDmaRequestMux0ADC0 request in the DMAMUX */
  DMAMUX_SetSource(DEMO_DMA_DMAMUX_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, DEMO_DMA_ADC0_DMA_REQUEST);
  /* Enable the channel 0 in the DMAMUX */
  DMAMUX_EnableChannel(DEMO_DMA_DMAMUX_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL);
  /* Create the DMA DEMO_DMA_ADC0_Handle handle */
  DMA_CreateHandle(&DEMO_DMA_ADC0_Handle, DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL);
  /* DMA auto-align mode for channel 0 */
  DMA_EnableAutoAlign(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, false);
  /* DMA cycle-steal request mode for channel 0 */
  DMA_EnableCycleSteal(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, true);
  /* DMA asynchronous request for channel 0 */
  DMA_EnableAsyncRequest(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, true);
  /* DMA auto stop request for channel 0 */
  DMA_EnableAutoStopRequest(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL, false);
  /* DMA interrupt request initialization for channel 0 */
  DMA_EnableInterrupts(DEMO_DMA_DMA_BASEADDR, DEMO_DMA_ADC0_DMA_CHANNEL);
  /* Enable interrupt DEMO_DMA_DMA_CH_INT_DONE_0_IRQN request in the NVIC */
  EnableIRQ(DEMO_DMA_DMA_CH_INT_DONE_0_IRQN);
}

/***********************************************************************************************************************
 * ADC16 initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'ADC16'
- type: 'adc16'
- mode: 'ADC'
- custom_name_enabled: 'true'
- type_id: 'adc16_2.2.0'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'ADC0'
- config_sets:
  - fsl_adc16:
    - adc16_config:
      - referenceVoltageSource: 'kADC16_ReferenceVoltageSourceVref'
      - clockSource: 'kADC16_ClockSourceAsynchronousClock'
      - enableAsynchronousClock: 'true'
      - clockDivider: 'kADC16_ClockDivider8'
      - resolution: 'kADC16_Resolution16Bit'
      - longSampleMode: 'kADC16_LongSampleCycle24'
      - hardwareAverageMode: 'kADC16_HardwareAverageDisabled'
      - enableHighSpeed: 'false'
      - enableLowPower: 'true'
      - enableContinuousConversion: 'false'
    - adc16_channel_mux_mode: 'kADC16_ChannelMuxA'
    - adc16_hardware_compare_config:
      - hardwareCompareModeEnable: 'false'
    - doAutoCalibration: 'true'
    - trigger: 'true'
    - enable_dma: 'true'
    - enable_irq: 'false'
    - adc_interrupt:
      - IRQn: 'ADC0_IRQn'
      - enable_interrrupt: 'enabled'
      - enable_priority: 'false'
      - priority: '0'
      - enable_custom_name: 'false'
    - adc16_channels_config:
      - 0:
        - channelName: ''
        - enableDifferentialConversion: 'false'
        - channelNumber: 'SE.26'
        - enableInterruptOnConversionCompleted: 'false'
        - channelGroup: '0'
        - initializeChannel: 'true'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
adc16_channel_config_t DEMO_ADC16_channelsConfig[1] = {
  {
    .channelNumber = 26U,
    .enableDifferentialConversion = false,
    .enableInterruptOnConversionCompleted = false,
  }
};
const adc16_config_t DEMO_ADC16_config = {
  .referenceVoltageSource = kADC16_ReferenceVoltageSourceVref,
  .clockSource = kADC16_ClockSourceAsynchronousClock,
  .enableAsynchronousClock = true,
  .clockDivider = kADC16_ClockDivider8,
  .resolution = kADC16_Resolution16Bit,
  .longSampleMode = kADC16_LongSampleCycle24,
  .hardwareAverageMode = kADC16_HardwareAverageDisabled,
  .enableHighSpeed = false,
  .enableLowPower = true,
  .enableContinuousConversion = false
};
const adc16_channel_mux_mode_t DEMO_ADC16_muxMode = kADC16_ChannelMuxA;

static void DEMO_ADC16_init(void) {
  /* Initialize ADC16 converter */
  ADC16_Init(DEMO_ADC16_PERIPHERAL, &DEMO_ADC16_config);
  /* Make sure, that hardware trigger is used */
  ADC16_EnableHardwareTrigger(DEMO_ADC16_PERIPHERAL, true);
  /* Configure channel multiplexing mode */
  ADC16_SetChannelMuxMode(DEMO_ADC16_PERIPHERAL, DEMO_ADC16_muxMode);
  /* Perform auto calibration */
  ADC16_DoAutoCalibration(DEMO_ADC16_PERIPHERAL);
  /* Enable DMA requests from ADC0 peripheral */
  ADC16_EnableDMA(DEMO_ADC16_PERIPHERAL, true);
  /* Initialize channel */
  ADC16_SetChannelConfig(DEMO_ADC16_PERIPHERAL, DEMO_ADC16_CH0_CONTROL_GROUP, &DEMO_ADC16_channelsConfig[0]);
}

/***********************************************************************************************************************
 * LPTMR initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'LPTMR'
- type: 'lptmr'
- mode: 'LPTMR_GENERAL'
- custom_name_enabled: 'true'
- type_id: 'lptmr_2.2.0'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'LPTMR0'
- config_sets:
  - fsl_lptmr:
    - lptmr_config:
      - timerMode: 'kLPTMR_TimerModeTimeCounter'
      - pinSelect: 'ALT.0'
      - pinPolarity: 'kLPTMR_PinPolarityActiveHigh'
      - enableFreeRunning: 'false'
      - bypassPrescaler: 'true'
      - prescalerClockSource: 'kLPTMR_PrescalerClock_1'
      - clockSource: 'BOARD_BootClockRUN'
      - value: 'kLPTMR_Prescale_Glitch_0'
      - timerPeriod: '100000'
      - enableTimerInInit: 'false'
    - enableInterrupt: 'false'
    - interrupt:
      - IRQn: 'LPTMR0_IRQn'
      - enable_interrrupt: 'enabled'
      - enable_priority: 'false'
      - priority: '0'
      - enable_custom_name: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const lptmr_config_t DEMO_LPTMR_config = {
  .timerMode = kLPTMR_TimerModeTimeCounter,
  .pinSelect = kLPTMR_PinSelectInput_0,
  .pinPolarity = kLPTMR_PinPolarityActiveHigh,
  .enableFreeRunning = false,
  .bypassPrescaler = true,
  .prescalerClockSource = kLPTMR_PrescalerClock_1,
  .value = kLPTMR_Prescale_Glitch_0
};

static void DEMO_LPTMR_init(void) {
  /* Initialize the LPTMR */
  LPTMR_Init(DEMO_LPTMR_PERIPHERAL, &DEMO_LPTMR_config);
  /* Set LPTMR period */
  LPTMR_SetTimerPeriod(DEMO_LPTMR_PERIPHERAL, DEMO_LPTMR_TICKS);
}

/***********************************************************************************************************************
 * NVIC initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'NVIC'
- type: 'nvic'
- mode: 'general'
- custom_name_enabled: 'false'
- type_id: 'nvic'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'NVIC'
- config_sets:
  - nvic:
    - interrupt_table:
      - 0: []
    - interrupts: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/* Empty initialization function (commented out)
static void DEMO_NVIC_init(void) {
} */

/***********************************************************************************************************************
 * VREF initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'VREF'
- type: 'vref'
- mode: 'vref'
- custom_name_enabled: 'false'
- type_id: 'vref_2.1.0'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'VREF'
- config_sets:
  - fsl_vref:
    - vref_config:
      - bufferMode: 'kVREF_ModeLowPowerBuffer'
    - vref_enable_trim: 'true'
    - vref_trim: '32'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const vref_config_t DEMO_VREF_config = {
  .bufferMode = kVREF_ModeLowPowerBuffer,
};

static void DEMO_VREF_init(void) {
  /* Initialize VREF module */
  VREF_Init(DEMO_VREF_PERIPHERAL, &DEMO_VREF_config);
  /* Change TRIM register value */
  VREF_SetTrimVal(DEMO_VREF_PERIPHERAL,DEMO_VREF_INITIAL_TRIM);
}

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void)
{
  /* Global initialization */
  DMAMUX_Init(DEMO_DMA_DMAMUX_BASEADDR);
  DMA_Init(DEMO_DMA_DMA_BASEADDR);

  /* Initialize components */
  DEMO_DMA_init();
  DEMO_ADC16_init();
  DEMO_LPTMR_init();
  DEMO_VREF_init();
}

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void)
{
}
