/* 
 * Copyright 2024 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */
/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
!!GlobalInfo
product: Peripherals v14.0
processor: MCXC242
package_id: MCXC242VLH
mcu_data: ksdk2_0
processor_version: 0.16.2
board: FRDM-MCXC242
functionalGroups:
- name: BOARD_InitPeripherals
  UUID: 0bda0542-9fee-4298-a815-70be9e2d392f
  called_from_default_init: true
  selectedCore: core0
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'system'
- type_id: 'system_54b53072540eeeb8f8e9343e71f28176'
- global_system_definitions:
  - user_definitions: ''
  - user_includes: ''
  - global_init: ''
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'gpio_adapter_common'
- type_id: 'gpio_adapter_common'
- global_gpio_adapter_common:
  - quick_selection: 'default'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/

/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
component:
- type: 'uart_cmsis_common'
- type_id: 'uart_cmsis_common'
- global_USART_CMSIS_common:
  - quick_selection: 'default'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "peripherals.h"

/***********************************************************************************************************************
 * BOARD_InitPeripherals functional group
 **********************************************************************************************************************/
/***********************************************************************************************************************
 * NVIC initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'NVIC'
- type: 'nvic'
- mode: 'general'
- custom_name_enabled: 'false'
- type_id: 'nvic'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'NVIC'
- config_sets:
  - nvic:
    - interrupt_table:
      - 0: []
      - 1: []
    - interrupts: []
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */

/* Empty initialization function (commented out)
static void NVIC_init(void) {
} */

/***********************************************************************************************************************
 * DEMO_RTC initialization code
 **********************************************************************************************************************/
/* clang-format off */
/* TEXT BELOW IS USED AS SETTING FOR TOOLS *************************************
instance:
- name: 'DEMO_RTC'
- type: 'rtc'
- mode: 'general'
- custom_name_enabled: 'true'
- type_id: 'rtc_2.3.0'
- functional_group: 'BOARD_InitPeripherals'
- peripheral: 'RTC'
- config_sets:
  - fsl_rtc:
    - clockConfig_t: []
    - rtc_config:
      - updateMode: 'false'
      - supervisorAccess: 'false'
      - compensationIntervalInt: '1'
      - compensationTimeInt: '0'
      - setDateTime: 'true'
      - rtc_datetime:
        - year: '2024'
        - month: '11'
        - day: '11'
        - hour: '11'
        - minute: '11'
        - second: '11'
      - setAlarm: 'false'
      - alarm_datetime:
        - year: '1970'
        - month: '1'
        - day: '1'
        - hour: '0'
        - minute: '0'
        - second: '0'
      - start: 'true'
    - interruptsCfg:
      - interruptSources: ''
      - isSecondsInterruptEnabled: 'true'
      - secondsInterrupt:
        - IRQn: 'RTC_Seconds_IRQn'
        - enable_interrrupt: 'enabled'
        - enable_priority: 'false'
        - priority: '1'
        - enable_custom_name: 'false'
      - isInterruptEnabled: 'true'
      - commonInterrupt:
        - IRQn: 'RTC_IRQn'
        - enable_interrrupt: 'enabled'
        - enable_priority: 'false'
        - priority: '0'
        - enable_custom_name: 'false'
 * BE CAREFUL MODIFYING THIS COMMENT - IT IS YAML SETTINGS FOR TOOLS **********/
/* clang-format on */
const rtc_config_t DEMO_RTC_config = {
  .wakeupSelect = false,
  .updateMode = false,
  .supervisorAccess = false,
  .compensationInterval = 0x0U,
  .compensationTime = 0x0U
};
rtc_datetime_t DEMO_RTC_dateTimeStruct = {
  .year = 2024U,
  .month = 11U,
  .day = 11U,
  .hour = 11U,
  .minute = 11U,
  .second = 11U
};

static void DEMO_RTC_init(void) {
  /* RTC initialization */
  RTC_Init(DEMO_RTC_PERIPHERAL, &DEMO_RTC_config);
  /* Stop RTC timer */
  RTC_StopTimer(DEMO_RTC_PERIPHERAL);
  /* Date and time initialization */
  RTC_SetDatetime(DEMO_RTC_PERIPHERAL, &DEMO_RTC_dateTimeStruct);
  /* Start RTC timer */
  RTC_StartTimer(DEMO_RTC_PERIPHERAL);
  /* Enable interrupt DEMO_RTC_COMMON_IRQN request in the NVIC */
  EnableIRQ(DEMO_RTC_COMMON_IRQN);
  /* Enable interrupt DEMO_RTC_SECONDS_IRQN request in the NVIC */
  EnableIRQ(DEMO_RTC_SECONDS_IRQN);
}

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void)
{
  /* Initialize components */
  DEMO_RTC_init();
}

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void)
{
  BOARD_InitPeripherals();
}
